
/**************************************************************************
 * This file is part of Celera Assembler, a software program that
 * assembles whole-genome shotgun reads into contigs and scaffolds.
 * Copyright (C) 1999-2004, Applera Corporation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received (LICENSE.txt) a copy of the GNU General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *************************************************************************/
#ifndef IAssemblyDB_HH
#define IAssemblyDB_HH

static const char *rcsid_IAssemblyDB_HH = "$Id: IAssemblyDB.hh,v 1.8 2011/12/29 09:26:03 brianwalenz Exp $";

#include "AS_global.h"
#include "SYS_UIDclient.h"

#include <string>
#include <IDBOutput.hh>

namespace AS_ARD {
   class IAssemblyDB {
      private:
         // disable copy constructor
         IAssemblyDB(IAssemblyDB &db){};

      protected:
         int numMDI;
         int numAFG;
         int numUTG;
         int numULK;
         int numCCO;
         int numCLK;
         int numSCF;

         UIDserver * uids;
         IDBOutput * db;

      public:
         IAssemblyDB(IDBOutput * out) : numMDI(0), numAFG(0), numUTG(0), numULK(0), numCCO(0), numCLK(0), numSCF(0), db(out){};
         virtual ~IAssemblyDB() { delete db; };

         virtual bool LoadDatabaseFromASMFile(FILE * fi, UIDserver * uid) = 0;
   };
}

#endif // IAssemblyDB_HH
