
/**************************************************************************
 * This file is part of Celera Assembler, a software program that
 * assembles whole-genome shotgun reads into contigs and scaffolds.
 * Copyright (C) 1999-2004, Applera Corporation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received (LICENSE.txt) a copy of the GNU General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *************************************************************************/

static const char *rcsid = "$Id: AS_UTL_GPL.c,v 1.3 2008/10/08 22:03:00 brianwalenz Exp $";

#include "AS_UTL_GPL.h"

void printGPL(FILE * fpout)
{
  fprintf(fpout, "		    GNU GENERAL PUBLIC LICENSE\n");
  fprintf(fpout, "		       Version 2, June 1991\n");
  fprintf(fpout, "\n");
  fprintf(fpout, " Copyright (C) 1989, 1991 Free Software Foundation, Inc.\n");
  fprintf(fpout, "                       59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
  fprintf(fpout, " Everyone is permitted to copy and distribute verbatim copies\n");
  fprintf(fpout, " of this license document, but changing it is not allowed.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "			    Preamble\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  The licenses for most software are designed to take away your\n");
  fprintf(fpout, "freedom to share and change it.  By contrast, the GNU General Public\n");
  fprintf(fpout, "License is intended to guarantee your freedom to share and change free\n");
  fprintf(fpout, "software--to make sure the software is free for all its users.  This\n");
  fprintf(fpout, "General Public License applies to most of the Free Software\n");
  fprintf(fpout, "Foundation's software and to any other program whose authors commit to\n");
  fprintf(fpout, "using it.  (Some other Free Software Foundation software is covered by\n");
  fprintf(fpout, "the GNU Library General Public License instead.)  You can apply it to\n");
  fprintf(fpout, "your programs, too.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  When we speak of free software, we are referring to freedom, not\n");
  fprintf(fpout, "price.  Our General Public Licenses are designed to make sure that you\n");
  fprintf(fpout, "have the freedom to distribute copies of free software (and charge for\n");
  fprintf(fpout, "this service if you wish), that you receive source code or can get it\n");
  fprintf(fpout, "if you want it, that you can change the software or use pieces of it\n");
  fprintf(fpout, "in new free programs; and that you know you can do these things.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  To protect your rights, we need to make restrictions that forbid\n");
  fprintf(fpout, "anyone to deny you these rights or to ask you to surrender the rights.\n");
  fprintf(fpout, "These restrictions translate to certain responsibilities for you if you\n");
  fprintf(fpout, "distribute copies of the software, or if you modify it.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  For example, if you distribute copies of such a program, whether\n");
  fprintf(fpout, "gratis or for a fee, you must give the recipients all the rights that\n");
  fprintf(fpout, "you have.  You must make sure that they, too, receive or can get the\n");
  fprintf(fpout, "source code.  And you must show them these terms so they know their\n");
  fprintf(fpout, "rights.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  We protect your rights with two steps: (1) copyright the software, and\n");
  fprintf(fpout, "(2) offer you this license which gives you legal permission to copy,\n");
  fprintf(fpout, "distribute and/or modify the software.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  Also, for each author's protection and ours, we want to make certain\n");
  fprintf(fpout, "that everyone understands that there is no warranty for this free\n");
  fprintf(fpout, "software.  If the software is modified by someone else and passed on, we\n");
  fprintf(fpout, "want its recipients to know that what they have is not the original, so\n");
  fprintf(fpout, "that any problems introduced by others will not reflect on the original\n");
  fprintf(fpout, "authors' reputations.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  Finally, any free program is threatened constantly by software\n");
  fprintf(fpout, "patents.  We wish to avoid the danger that redistributors of a free\n");
  fprintf(fpout, "program will individually obtain patent licenses, in effect making the\n");
  fprintf(fpout, "program proprietary.  To prevent this, we have made it clear that any\n");
  fprintf(fpout, "patent must be licensed for everyone's free use or not licensed at all.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  The precise terms and conditions for copying, distribution and\n");
  fprintf(fpout, "modification follow.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "		    GNU GENERAL PUBLIC LICENSE\n");
  fprintf(fpout, "   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  0. This License applies to any program or other work which contains\n");
  fprintf(fpout, "a notice placed by the copyright holder saying it may be distributed\n");
  fprintf(fpout, "under the terms of this General Public License.  The \"Program\", below,\n");
  fprintf(fpout, "refers to any such program or work, and a \"work based on the Program\"\n");
  fprintf(fpout, "means either the Program or any derivative work under copyright law:\n");
  fprintf(fpout, "that is to say, a work containing the Program or a portion of it,\n");
  fprintf(fpout, "either verbatim or with modifications and/or translated into another\n");
  fprintf(fpout, "language.  (Hereinafter, translation is included without limitation in\n");
  fprintf(fpout, "the term \"modification\".)  Each licensee is addressed as \"you\".\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "Activities other than copying, distribution and modification are not\n");
  fprintf(fpout, "covered by this License; they are outside its scope.  The act of\n");
  fprintf(fpout, "running the Program is not restricted, and the output from the Program\n");
  fprintf(fpout, "is covered only if its contents constitute a work based on the\n");
  fprintf(fpout, "Program (independent of having been made by running the Program).\n");
  fprintf(fpout, "Whether that is true depends on what the Program does.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  1. You may copy and distribute verbatim copies of the Program's\n");
  fprintf(fpout, "source code as you receive it, in any medium, provided that you\n");
  fprintf(fpout, "conspicuously and appropriately publish on each copy an appropriate\n");
  fprintf(fpout, "copyright notice and disclaimer of warranty; keep intact all the\n");
  fprintf(fpout, "notices that refer to this License and to the absence of any warranty;\n");
  fprintf(fpout, "and give any other recipients of the Program a copy of this License\n");
  fprintf(fpout, "along with the Program.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "You may charge a fee for the physical act of transferring a copy, and\n");
  fprintf(fpout, "you may at your option offer warranty protection in exchange for a fee.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  2. You may modify your copy or copies of the Program or any portion\n");
  fprintf(fpout, "of it, thus forming a work based on the Program, and copy and\n");
  fprintf(fpout, "distribute such modifications or work under the terms of Section 1\n");
  fprintf(fpout, "above, provided that you also meet all of these conditions:\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    a) You must cause the modified files to carry prominent notices\n");
  fprintf(fpout, "    stating that you changed the files and the date of any change.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    b) You must cause any work that you distribute or publish, that in\n");
  fprintf(fpout, "    whole or in part contains or is derived from the Program or any\n");
  fprintf(fpout, "    part thereof, to be licensed as a whole at no charge to all third\n");
  fprintf(fpout, "    parties under the terms of this License.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    c) If the modified program normally reads commands interactively\n");
  fprintf(fpout, "    when run, you must cause it, when started running for such\n");
  fprintf(fpout, "    interactive use in the most ordinary way, to print or display an\n");
  fprintf(fpout, "    announcement including an appropriate copyright notice and a\n");
  fprintf(fpout, "    notice that there is no warranty (or else, saying that you provide\n");
  fprintf(fpout, "    a warranty) and that users may redistribute the program under\n");
  fprintf(fpout, "    these conditions, and telling the user how to view a copy of this\n");
  fprintf(fpout, "    License.  (Exception: if the Program itself is interactive but\n");
  fprintf(fpout, "    does not normally print such an announcement, your work based on\n");
  fprintf(fpout, "    the Program is not required to print an announcement.)\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "These requirements apply to the modified work as a whole.  If\n");
  fprintf(fpout, "identifiable sections of that work are not derived from the Program,\n");
  fprintf(fpout, "and can be reasonably considered independent and separate works in\n");
  fprintf(fpout, "themselves, then this License, and its terms, do not apply to those\n");
  fprintf(fpout, "sections when you distribute them as separate works.  But when you\n");
  fprintf(fpout, "distribute the same sections as part of a whole which is a work based\n");
  fprintf(fpout, "on the Program, the distribution of the whole must be on the terms of\n");
  fprintf(fpout, "this License, whose permissions for other licensees extend to the\n");
  fprintf(fpout, "entire whole, and thus to each and every part regardless of who wrote it.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "Thus, it is not the intent of this section to claim rights or contest\n");
  fprintf(fpout, "your rights to work written entirely by you; rather, the intent is to\n");
  fprintf(fpout, "exercise the right to control the distribution of derivative or\n");
  fprintf(fpout, "collective works based on the Program.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "In addition, mere aggregation of another work not based on the Program\n");
  fprintf(fpout, "with the Program (or with a work based on the Program) on a volume of\n");
  fprintf(fpout, "a storage or distribution medium does not bring the other work under\n");
  fprintf(fpout, "the scope of this License.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  3. You may copy and distribute the Program (or a work based on it,\n");
  fprintf(fpout, "under Section 2) in object code or executable form under the terms of\n");
  fprintf(fpout, "Sections 1 and 2 above provided that you also do one of the following:\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    a) Accompany it with the complete corresponding machine-readable\n");
  fprintf(fpout, "    source code, which must be distributed under the terms of Sections\n");
  fprintf(fpout, "    1 and 2 above on a medium customarily used for software interchange; or,\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    b) Accompany it with a written offer, valid for at least three\n");
  fprintf(fpout, "    years, to give any third party, for a charge no more than your\n");
  fprintf(fpout, "    cost of physically performing source distribution, a complete\n");
  fprintf(fpout, "    machine-readable copy of the corresponding source code, to be\n");
  fprintf(fpout, "    distributed under the terms of Sections 1 and 2 above on a medium\n");
  fprintf(fpout, "    customarily used for software interchange; or,\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    c) Accompany it with the information you received as to the offer\n");
  fprintf(fpout, "    to distribute corresponding source code.  (This alternative is\n");
  fprintf(fpout, "    allowed only for noncommercial distribution and only if you\n");
  fprintf(fpout, "    received the program in object code or executable form with such\n");
  fprintf(fpout, "    an offer, in accord with Subsection b above.)\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "The source code for a work means the preferred form of the work for\n");
  fprintf(fpout, "making modifications to it.  For an executable work, complete source\n");
  fprintf(fpout, "code means all the source code for all modules it contains, plus any\n");
  fprintf(fpout, "associated interface definition files, plus the scripts used to\n");
  fprintf(fpout, "control compilation and installation of the executable.  However, as a\n");
  fprintf(fpout, "special exception, the source code distributed need not include\n");
  fprintf(fpout, "anything that is normally distributed (in either source or binary\n");
  fprintf(fpout, "form) with the major components (compiler, kernel, and so on) of the\n");
  fprintf(fpout, "operating system on which the executable runs, unless that component\n");
  fprintf(fpout, "itself accompanies the executable.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "If distribution of executable or object code is made by offering\n");
  fprintf(fpout, "access to copy from a designated place, then offering equivalent\n");
  fprintf(fpout, "access to copy the source code from the same place counts as\n");
  fprintf(fpout, "distribution of the source code, even though third parties are not\n");
  fprintf(fpout, "compelled to copy the source along with the object code.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  4. You may not copy, modify, sublicense, or distribute the Program\n");
  fprintf(fpout, "except as expressly provided under this License.  Any attempt\n");
  fprintf(fpout, "otherwise to copy, modify, sublicense or distribute the Program is\n");
  fprintf(fpout, "void, and will automatically terminate your rights under this License.\n");
  fprintf(fpout, "However, parties who have received copies, or rights, from you under\n");
  fprintf(fpout, "this License will not have their licenses terminated so long as such\n");
  fprintf(fpout, "parties remain in full compliance.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  5. You are not required to accept this License, since you have not\n");
  fprintf(fpout, "signed it.  However, nothing else grants you permission to modify or\n");
  fprintf(fpout, "distribute the Program or its derivative works.  These actions are\n");
  fprintf(fpout, "prohibited by law if you do not accept this License.  Therefore, by\n");
  fprintf(fpout, "modifying or distributing the Program (or any work based on the\n");
  fprintf(fpout, "Program), you indicate your acceptance of this License to do so, and\n");
  fprintf(fpout, "all its terms and conditions for copying, distributing or modifying\n");
  fprintf(fpout, "the Program or works based on it.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  6. Each time you redistribute the Program (or any work based on the\n");
  fprintf(fpout, "Program), the recipient automatically receives a license from the\n");
  fprintf(fpout, "original licensor to copy, distribute or modify the Program subject to\n");
  fprintf(fpout, "these terms and conditions.  You may not impose any further\n");
  fprintf(fpout, "restrictions on the recipients' exercise of the rights granted herein.\n");
  fprintf(fpout, "You are not responsible for enforcing compliance by third parties to\n");
  fprintf(fpout, "this License.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  7. If, as a consequence of a court judgment or allegation of patent\n");
  fprintf(fpout, "infringement or for any other reason (not limited to patent issues),\n");
  fprintf(fpout, "conditions are imposed on you (whether by court order, agreement or\n");
  fprintf(fpout, "otherwise) that contradict the conditions of this License, they do not\n");
  fprintf(fpout, "excuse you from the conditions of this License.  If you cannot\n");
  fprintf(fpout, "distribute so as to satisfy simultaneously your obligations under this\n");
  fprintf(fpout, "License and any other pertinent obligations, then as a consequence you\n");
  fprintf(fpout, "may not distribute the Program at all.  For example, if a patent\n");
  fprintf(fpout, "license would not permit royalty-free redistribution of the Program by\n");
  fprintf(fpout, "all those who receive copies directly or indirectly through you, then\n");
  fprintf(fpout, "the only way you could satisfy both it and this License would be to\n");
  fprintf(fpout, "refrain entirely from distribution of the Program.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "If any portion of this section is held invalid or unenforceable under\n");
  fprintf(fpout, "any particular circumstance, the balance of the section is intended to\n");
  fprintf(fpout, "apply and the section as a whole is intended to apply in other\n");
  fprintf(fpout, "circumstances.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "It is not the purpose of this section to induce you to infringe any\n");
  fprintf(fpout, "patents or other property right claims or to contest validity of any\n");
  fprintf(fpout, "such claims; this section has the sole purpose of protecting the\n");
  fprintf(fpout, "integrity of the free software distribution system, which is\n");
  fprintf(fpout, "implemented by public license practices.  Many people have made\n");
  fprintf(fpout, "generous contributions to the wide range of software distributed\n");
  fprintf(fpout, "through that system in reliance on consistent application of that\n");
  fprintf(fpout, "system; it is up to the author/donor to decide if he or she is willing\n");
  fprintf(fpout, "to distribute software through any other system and a licensee cannot\n");
  fprintf(fpout, "impose that choice.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "This section is intended to make thoroughly clear what is believed to\n");
  fprintf(fpout, "be a consequence of the rest of this License.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  8. If the distribution and/or use of the Program is restricted in\n");
  fprintf(fpout, "certain countries either by patents or by copyrighted interfaces, the\n");
  fprintf(fpout, "original copyright holder who places the Program under this License\n");
  fprintf(fpout, "may add an explicit geographical distribution limitation excluding\n");
  fprintf(fpout, "those countries, so that distribution is permitted only in or among\n");
  fprintf(fpout, "countries not thus excluded.  In such case, this License incorporates\n");
  fprintf(fpout, "the limitation as if written in the body of this License.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  9. The Free Software Foundation may publish revised and/or new versions\n");
  fprintf(fpout, "of the General Public License from time to time.  Such new versions will\n");
  fprintf(fpout, "be similar in spirit to the present version, but may differ in detail to\n");
  fprintf(fpout, "address new problems or concerns.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "Each version is given a distinguishing version number.  If the Program\n");
  fprintf(fpout, "specifies a version number of this License which applies to it and \"any\n");
  fprintf(fpout, "later version\", you have the option of following the terms and conditions\n");
  fprintf(fpout, "either of that version or of any later version published by the Free\n");
  fprintf(fpout, "Software Foundation.  If the Program does not specify a version number of\n");
  fprintf(fpout, "this License, you may choose any version ever published by the Free Software\n");
  fprintf(fpout, "Foundation.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  10. If you wish to incorporate parts of the Program into other free\n");
  fprintf(fpout, "programs whose distribution conditions are different, write to the author\n");
  fprintf(fpout, "to ask for permission.  For software which is copyrighted by the Free\n");
  fprintf(fpout, "Software Foundation, write to the Free Software Foundation; we sometimes\n");
  fprintf(fpout, "make exceptions for this.  Our decision will be guided by the two goals\n");
  fprintf(fpout, "of preserving the free status of all derivatives of our free software and\n");
  fprintf(fpout, "of promoting the sharing and reuse of software generally.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "			    NO WARRANTY\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY\n");
  fprintf(fpout, "FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN\n");
  fprintf(fpout, "OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES\n");
  fprintf(fpout, "PROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED\n");
  fprintf(fpout, "OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n");
  fprintf(fpout, "MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS\n");
  fprintf(fpout, "TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE\n");
  fprintf(fpout, "PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,\n");
  fprintf(fpout, "REPAIR OR CORRECTION.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING\n");
  fprintf(fpout, "WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR\n");
  fprintf(fpout, "REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,\n");
  fprintf(fpout, "INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING\n");
  fprintf(fpout, "OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED\n");
  fprintf(fpout, "TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY\n");
  fprintf(fpout, "YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER\n");
  fprintf(fpout, "PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\n");
  fprintf(fpout, "POSSIBILITY OF SUCH DAMAGES.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "		     END OF TERMS AND CONDITIONS\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "	    How to Apply These Terms to Your New Programs\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  If you develop a new program, and you want it to be of the greatest\n");
  fprintf(fpout, "possible use to the public, the best way to achieve this is to make it\n");
  fprintf(fpout, "free software which everyone can redistribute and change under these terms.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  To do so, attach the following notices to the program.  It is safest\n");
  fprintf(fpout, "to attach them to the start of each source file to most effectively\n");
  fprintf(fpout, "convey the exclusion of warranty; and each file should have at least\n");
  fprintf(fpout, "the \"copyright\" line and a pointer to where the full notice is found.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    <one line to give the program's name and a brief idea of what it does.>\n");
  fprintf(fpout, "    Copyright (C) <year>  <name of author>\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    This program is free software; you can redistribute it and/or modify\n");
  fprintf(fpout, "    it under the terms of the GNU General Public License as published by\n");
  fprintf(fpout, "    the Free Software Foundation; either version 2 of the License, or\n");
  fprintf(fpout, "    (at your option) any later version.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    This program is distributed in the hope that it will be useful,\n");
  fprintf(fpout, "    but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
  fprintf(fpout, "    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
  fprintf(fpout, "    GNU General Public License for more details.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    You should have received a copy of the GNU General Public License\n");
  fprintf(fpout, "    along with this program; if not, write to the Free Software\n");
  fprintf(fpout, "    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "Also add information on how to contact you by electronic and paper mail.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "If the program is interactive, make it output a short notice like this\n");
  fprintf(fpout, "when it starts in an interactive mode:\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "    Gnomovision version 69, Copyright (C) year name of author\n");
  fprintf(fpout, "    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.\n");
  fprintf(fpout, "    This is free software, and you are welcome to redistribute it\n");
  fprintf(fpout, "    under certain conditions; type `show c' for details.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "The hypothetical commands `show w' and `show c' should show the appropriate\n");
  fprintf(fpout, "parts of the General Public License.  Of course, the commands you use may\n");
  fprintf(fpout, "be called something other than `show w' and `show c'; they could even be\n");
  fprintf(fpout, "mouse-clicks or menu items--whatever suits your program.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "You should also get your employer (if you work as a programmer) or your\n");
  fprintf(fpout, "school, if any, to sign a \"copyright disclaimer\" for the program, if\n");
  fprintf(fpout, "necessary.  Here is a sample; alter the names:\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  Yoyodyne, Inc., hereby disclaims all copyright interest in the program\n");
  fprintf(fpout, "  `Gnomovision' (which makes passes at compilers) written by James Hacker.\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "  <signature of Ty Coon>, 1 April 1989\n");
  fprintf(fpout, "  Ty Coon, President of Vice\n");
  fprintf(fpout, "\n");
  fprintf(fpout, "This General Public License does not permit incorporating your program into\n");
  fprintf(fpout, "proprietary programs.  If your program is a subroutine library, you may\n");
  fprintf(fpout, "consider it more useful to permit linking proprietary applications with the\n");
  fprintf(fpout, "library.  If this is what you want to do, use the GNU Library General\n");
  fprintf(fpout, "Public License instead of this License.\n");
}
