
/**************************************************************************
 * This file is part of Celera Assembler, a software program that
 * assembles whole-genome shotgun reads into contigs and scaffolds.
 * Copyright (C) 1999-2004, Applera Corporation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received (LICENSE.txt) a copy of the GNU General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *************************************************************************/

#ifndef HASH_H
#define HASH_H

static const char *rcsid_HASH_H = "$Id: hash.h,v 1.6 2008/10/08 22:03:02 brianwalenz Exp $";

typedef void HashTable;

HashTable *NewHashTable(int size);
int HashLookup(char *entry, HashTable *table, int *isdef);
int HashAdd(char *entry, HashTable *table, int isdef);
char *HashRefButNoDef(HashTable *table);
char *GetLastHash(HashTable *table);
void PrintHashTable(HashTable *table);

#endif
